#!/bin/sh
#
# Copyright (C) 2009 The Duo developers.
#
# This file is part of duo.
#
# duo is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

# CSS Patch.
PATCH="\n/* Customisation.\n\
 */\n\
pre.rst-literal-block       { font-family: Courier, \"Courier New\", monospace;\n\
                              background: #f0f0f0;\n\
                              margin-left: 4em; margin-right: 4em;\n\
                              padding: 0.6em; }\n\
table.rst-docutils          { border-style: hidden; margin-bottom: 1em; }\n\
table.rst-docutils td       { padding: 0.8em; border: 2px; border-style: solid; }"

# Experimental modules should not be documented mainstream.
EXCLUDES="--exclude duo.transport.chat \
          --exclude duo.ui.gnomish \
          --exclude duo.ui.dreadful \
          --exclude duo.rules.uno"

# Generation options.
GENERATION="--inheritance grouped --include-log"

# Output options.
OUTPUT="--name Duo \
        --url http://duo.tuxfamily.org"

type epydoc > /dev/null 2>&1
if [ $? -eq 0 ]; then
    epydoc -o api -v --html $EXCLUDES $GENERATION $OUTPUT duo
    if [ $? ]; then
        echo "Patching CSS file."
        echo "$PATCH" >> api/epydoc.css
    fi
else
    echo 'Please install epydoc to generate API documentation.'
fi
